source: scripts/locker-build @ 24ccc01

release-1.10release-1.4release-1.5release-1.6release-1.7release-1.8release-1.9
Last change on this file since 24ccc01 was 130633c, checked in by Nelson Elhage <nelhage@mit.edu>, 15 years ago
Merge branch 'automake' Conflicts: Makefile.in libfaim/Makefile.in owl.h
  • Property mode set to 100755
File size: 2.8 KB
RevLine 
[de9edab]1#!/bin/bash
[56e4869]2
3#########################################################
4# Build script to build BarnOwl for the locker.
5
[3043064]6# Usage: locker-build [-n] [-o OUTPUT-TGZ] SOURCE-TARBALL
[56e4869]7# -n is a dry-run, and drops to a shell in the build directory
8# -o does the install into a temporary directory and tars it into the
9#    specified tarball instead.
10# SOURCE-TARBALL is a source tarball, created by do-release
[5c81472]11
12die() {
[67dd774]13    echo "$@" 2>&1;
14    if [ -n "$TMPDIR" ]; then
15        if [ -n "$DRYRUN" ]; then
16            echo "Dropping to a shell to investigate...";
17            $SHELL
18        fi
19    fi
20    exit 1;
[56e4869]21}
22
23usage () {
[3043064]24    echo "Usage: $0 [-n] [-o OUTPUT-TGZ] SOURCE-TARBALL"
[56e4869]25    exit 2;
[5c81472]26}
27
[56e4869]28exittrap() { :; }
29for sig in 1 2 13 15; do trap "exit $(($sig + 128))" $sig; done
30trap 'exittrap' EXIT
31
32SRC_TGZ=
33OUT_TGZ=
[5c81472]34DRYRUN=
[56e4869]35
36set -- `getopt no: "$@"`
37[ $? -eq 0 ] || usage
38
39for opt
40do
41    case "$opt" in
42        -n)
43            DRYRUN=1; shift ;;
44        -o)
45            OUT_TGZ="$2"; shift 2;;
46        --)
47            shift; break ;;
48    esac
49done
[5c81472]50
[3043064]51SRC_TGZ="$1"
[56e4869]52
53test -z "$SRC_TGZ"  && usage
54
[5c81472]55
56ATHENA_SYS="${ATHENA_SYS:-$(machtype -S)}"
57
58if [ "$(uname)" = "SunOS" ]; then
59    MAKE=gmake
60    TAR=gtar
61else
62    MAKE=make
63    TAR=tar
64fi
65
66attach barnowl
67aklog
68
[56e4869]69TMPDIR=$(mktemp -d /tmp/barnowl-build-XXXXXX) || die "Unable to mktemp"
[5c81472]70
[56e4869]71exittrap() { rm -rf "$TMPDIR"; }
[5c81472]72
[67dd774]73$TAR -C "$TMPDIR" -xzf "$SRC_TGZ" || die "Unable to untar"
[5c81472]74
[56e4869]75(
76    cd "$TMPDIR"/* || die "Unable to cd to $TMPDIR"
[db98968]77    VERS=$(perl -ne 'print $1 if m{^AC_INIT\(\[[^\]]+\],\s*\[([^\]]+)\]}' configure.ac)
[3043064]78    test -z "$VERS" && die "Unable to detect barnowl version."
79
80    echo "Building BarnOwl version $VERS"
[5c81472]81
[56e4869]82    BARNOWL="/afs/sipb.mit.edu/project/barnowl/arch/$ATHENA_SYS"
83    export PKG_CONFIG_PATH="$BARNOWL/lib/pkgconfig"
[5c81472]84
[56e4869]85    CFLAGS="-I$BARNOWL/include" \
86        LDFLAGS="-L$BARNOWL/lib -Wl,-R$BARNOWL/lib" \
87        ./configure --exec-prefix="/mit/barnowl/arch/$ATHENA_SYS" \
[3043064]88        --prefix="/mit/barnowl/builds/barnowl-$VERS" --mandir=/mit/barnowl/man \
89        --program-suffix="-$VERS" \
[e477a53]90        --with-zephyr --without-stack-protector \
[56e4869]91        || die "configure failed"
[5c81472]92
[56e4869]93    $MAKE clean  || die "make clean failed"
[5c81472]94
[56e4869]95    CPUS=$(athinfo localhost cpuspeed | grep -c MHz)
96    if [ "$CPUS" = 0 ]; then
97        CPUS=1
98    fi
[5c81472]99
[3043064]100    $MAKE -j$CPUS all || die "make failed"
[5c81472]101
[56e4869]102    if [ -n "$DRYRUN" ]; then
103        echo "Build completed; Dropping to a shell..."
104        $SHELL
[5c81472]105    else
[56e4869]106        if [ -n "$OUT_TGZ" ]; then
107            mkdir tgz
[3043064]108            $MAKE DESTDIR=tgz install || die "Install failed"
[56e4869]109        else
[3043064]110            $MAKE install || die "Install failed"
[56e4869]111        fi
[5c81472]112    fi
[56e4869]113)
114
[67dd774]115if [ "$?" -ne 0 ]; then
116    exit "$?"
117fi
118
[56e4869]119if [ -n "$OUT_TGZ" ]; then
120    $TAR -C "$TMPDIR/"*/tgz -czvf "$OUT_TGZ" . || die "Make tarball failed"
[5c81472]121fi
122
123rm -rf "$TMPDIR"
[56e4869]124exittrap() { :; }
Note: See TracBrowser for help on using the repository browser.